---
- name: Check if docker folders exist if not create
  file:
    path: /mnt/data/docker
    state: directory
    owner: root
    group: root

- name: Check if folders exist if not create
  file:
    path: "{{ item }}"
    state: directory
    owner: root
    group: root
  loop: "{{ ftpserver_directories }}"

- name: Check if cert exist in certbot
  stat:
    path: "{{ global_cert_path }}/live/{{ cert_domain }}"
  register: certexist

- name: "Add the user {{ ftp_user }}"
  ansible.builtin.user:
    name: "{{ ftp_user }}"
    uid: 1100

- name: Check if folders data exist if not create
  file:
    path: "{{ item }}"
    state: directory
    owner: 1100
    group: 1100
  loop: "{{ ftpserver_data_dir }}"

- name: Check if cert exist in pureftp
  stat:
    path: /mnt/data/ftp_config/pureftpd.pem
  register: pureftpcert

- name: Create pureftp cert
  shell:
    cmd: "cat {{ global_cert_path }}/live/{{ cert_domain }}/cert.pem {{ global_cert_path }}/live/{{ cert_domain }}/privkey.pem > /mnt/data/ftp_config/pureftpd.pem"
  when: not pureftpcert.stat.exists and certexist.stat.exists

- name: Copy nginx config
  template:
    src: nginx.j2
    dest: /mnt/data/nginx/nginx.conf
  register: conf_nginx

- name: Copy pureftp flags
  copy:
    src: pureftpd.flags
    dest: /mnt/data/ftp_config/pureftpd.flags
  register: conf_pureftp

- name: Copy script to check cert
  template:
    src: compare-cert.j2
    dest: /mnt/data/certbot/compare-cert.sh
    mode: u=rwx,g=rx,o=r

- name: Create cron job for cert check
  cron:
    name: Check if service should be restarted
    minute: "30"
    hour: "1"
    user: root
    job: /mnt/data/certbot/compare-cert.sh
    cron_file: letsencryp_check

- name: Create docker-compose file
  template:
    src: docker-compose.j2
    dest: /mnt/data/docker/docker-compose.yaml
  register: conf_docker

- name: Tear down services
  community.docker.docker_compose:
    project_src: /mnt/data/docker
    state: absent
  when: conf_nginx.changed or conf_pureftp.changed or conf_docker.changed

- name: Create and start services
  community.docker.docker_compose:
    project_src: /mnt/data/docker
  register: output
  when: conf_nginx.changed or conf_pureftp.changed or conf_docker.changed

#- name: Show results
#  ansible.builtin.debug:
#    var: nginx

- name: Verify that nginx and ftpserver are running
  ansible.builtin.assert:
    that:
      - "output.services.pureftpd.pureftpd.state.running"
      - "output.services.nginx.nginx.state.running"
  when: conf_nginx.changed or conf_pureftp.changed or conf_docker.changed
